summaryrefslogtreecommitdiff
path: root/zforce.in
diff options
context:
space:
mode:
Diffstat (limited to 'zforce.in')
-rw-r--r--zforce.in69
1 files changed, 69 insertions, 0 deletions
diff --git a/zforce.in b/zforce.in
new file mode 100644
index 0000000..82ad330
--- /dev/null
+++ b/zforce.in
@@ -0,0 +1,69 @@
+#!/bin/sh
+# zforce: force a gz extension on all gzip files so that gzip will not
+# compress them twice.
+#
+# This can be useful for files with names truncated after a file transfer.
+# 12345678901234 is renamed to 12345678901.gz
+
+
+# Copyright (C) 2002, 2007, 2010-2016 Free Software Foundation, Inc.
+# Copyright (C) 1993 Jean-loup Gailly
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+version="zforce (gzip) @VERSION@
+Copyright (C) 2010-2016 Free Software Foundation, Inc.
+This is free software. You may redistribute copies of it under the terms of
+the GNU General Public License <http://www.gnu.org/licenses/gpl.html>.
+There is NO WARRANTY, to the extent permitted by law.
+
+Written by Jean-loup Gailly."
+
+usage="Usage: $0 [FILE]...
+Force a .gz extension on all compressed FILEs so that gzip will
+not compress them twice.
+
+Report bugs to <bug-gzip@gnu.org>."
+
+if test $# = 0; then
+ echo >&2 "$0: invalid number of operands; try \`$0 --help' for help"
+ exit 1
+fi
+
+res=0
+for i do
+ case "$i" in
+ --h*) exec echo "$usage";;
+ --v*) exec echo "$version";;
+ *[-.]z | *[-.]gz | *.t[ag]z) continue;;
+ esac
+
+ if test ! -f "$i" ; then
+ echo zforce: $i not a file
+ res=1
+ continue
+ fi
+
+ if gzip -lv < "$i" 2>/dev/null | grep '^defl' > /dev/null; then
+
+ new="$i.gz"
+ if mv "$i" "$new"; then
+ echo $i -- replaced with $new
+ else
+ res=$?
+ fi
+ fi
+done
+exit $res